/*-------------------------------------------------------------*\
 | Fractal.cpp                                                 |
\*-------------------------------------------------------------*/

#include <Windows.h>                 
#include <commdlg.h>
#include <stdlib.h>
#include <string.h>
#include <mem.h>
#include <math.h>

#include <stdio.h>

#include "FracMenu.h"

/*-------------------------------------------------------------*\
 |                  Prottipos das funes                     |
\*-------------------------------------------------------------*/

LRESULT CALLBACK FractalWndProc (HWND, UINT, WPARAM, LPARAM);
void Floco (HDC, float, float, float, float, int);
void Triangulo (HDC, float, float, float,
                     float, float, float, int);

/*-------------------------------------------------------------*\
 |                     Variveis Globais                       |
\*-------------------------------------------------------------*/

/*-------------------------------------------------------------*\
 |                   Funo principal WinMain                  |
\*-------------------------------------------------------------*/

int PASCAL WinMain (HANDLE hInstance,
		    HANDLE hPrevInstance,
		    LPSTR  lpCmdLine,
		    int    nCmdShow)
{
  // J existe alguma instncia do programa Fracal
  if (hPrevInstance) {
    MessageBeep (MB_ICONEXCLAMATION);
    exit (EXIT_FAILURE);
  }

  WNDCLASS  wc;
  wc.lpszClassName = "FRAC:MAIN";
  wc.hInstance     = hInstance;
  wc.lpfnWndProc   = FractalWndProc;
  wc.hCursor       = LoadCursor (NULL, IDC_ARROW);
  wc.hIcon         = LoadIcon (hInstance, "FracIcone");
  wc.lpszMenuName  = "FracMenu";
  wc.hbrBackground = COLOR_WINDOW + 1;
  wc.style         = CS_HREDRAW | CS_VREDRAW;
  wc.cbClsExtra    = 0;
  wc.cbWndExtra    = 0;

  if (!RegisterClass (&wc))
    return FALSE;   

  HWND hwnd;
  hwnd = CreateWindow ("FRAC:MAIN",          // Nome da classe
		       "Fractal",            // Ttulo
		       WS_OVERLAPPEDWINDOW,  // Estilo
		       10,                   // x 
		       10,                   // y 
		       500,                  // cx
                       150,                  // cy
		       NULL,                 // Pai
		       NULL,                 // Menu
		       hInstance,            // Criador
		       NULL                  // Parmetro
		      );

  ShowWindow (hwnd, nCmdShow);

  MSG msg;
  while (GetMessage (&msg, (HWND) NULL, 0, 0)) {
    TranslateMessage (&msg);
    DispatchMessage (&msg);
  }
 
  return 0L;  
} 

/*-------------------------------------------------------------*\
 |              Funo do Windows: FractalWndProc              |
\*-------------------------------------------------------------*/

LRESULT CALLBACK FractalWndProc (HWND   hwnd,
		                 UINT   msg,
		   	         WPARAM wParam,
			         LPARAM lParam)
{
  static int fractal = FLOCO_1;

  switch (msg) {
    case WM_CLOSE: {
      MessageBeep (MB_ICONQUESTION); 
      if (MessageBox (hwnd, "Tem certeza?", "Sair do Fractal",
		      MB_ICONQUESTION | MB_OKCANCEL) == IDOK) {
	WinHelp (hwnd, "Dump.hlp", HELP_QUIT, NULL);
	DestroyWindow (hwnd);
      }
      return 0L;
    }

    case WM_DESTROY: {
      PostQuitMessage (0);
      break;
    }

    case WM_COMMAND: {
      switch (wParam) {
	case SAIR: // Sair do programa
          PostMessage (hwnd, WM_CLOSE, 0, 0L);
	  break;

	default:
	  fractal = wParam;
	  RedrawWindow (hwnd, NULL, NULL, RDW_INVALIDATE);
	  break;
      }
    }

    case WM_PAINT: {
      PAINTSTRUCT ps;

      BeginPaint (hwnd, &ps);
      RECT janela;
      GetClientRect (hwnd, &janela);
      float x = (float) janela.right,
	    y = (float) janela.bottom;

      Rectangle (ps.hdc, janela.left, janela.top,
			 janela.right, janela.bottom);
      HCURSOR hcursor;
      hcursor = SetCursor (LoadCursor (NULL, IDC_WAIT));

      switch (fractal) {
	case FLOCO_1: {
	  Floco (ps.hdc, 5.0, y - 5.0, x -5.0, y - 5.0, 1); 
	  break;
        }
	case FLOCO_2: {
	  Floco (ps.hdc, 5.0, y - 5.0, x -5.0, y - 5.0, 2);
	  break;
        }
	case FLOCO_3: {
	  Floco (ps.hdc, 5.0, y - 5.0, x -5.0, y - 5.0, 3); 
	  break;
        }
	case FLOCO_4: {
	  Floco (ps.hdc, 5.0, y - 5.0, x -5.0, y - 5.0, 4); 
	  break;
        }
	case FLOCO_5: {
	  Floco (ps.hdc, 5.0, y - 5.0, x -5.0, y - 5.0, 5); 
	  break;
        }
	case FLOCO_6: {
	  Floco (ps.hdc, 5.0, y - 5.0, x -5.0, y - 5.0, 6); 
	  break;
        }
	case FLOCO_7: {
	  Floco (ps.hdc, 5.0, y - 5.0, x -5.0, y - 5.0, 7); 
	  break;
        }
	case FLOCO_8: {
	  Floco (ps.hdc, 5.0, y - 5.0, x -5.0, y - 5.0, 8); 
	  break;
        }
	case FLOCO_9: {
	  Floco (ps.hdc, 5.0, y - 5.0, x -5.0, y - 5.0, 9); 
	  break;
	}
	case FLOCO_10: {
	  Floco (ps.hdc, 5.0, y - 5.0, x - 5.0, y - 5.0, 10); 
	  break;
	}
	case TRIANGULO_1: {
	  Triangulo (ps.hdc, 5.0, y - 5.0, x - 5.0, y - 5.0, x / 2, 5.0, 1);
          break;
	}
  	case TRIANGULO_2: {
  	  Triangulo (ps.hdc, 5.0, y - 5.0, x - 5.0, y - 5.0, x / 2, 5.0, 2);
          break;
	}
	case TRIANGULO_3: {
	  Triangulo (ps.hdc, 5.0, y - 5.0, x - 5.0, y - 5.0, x / 2, 5.0, 3);
          break;
	}
	case TRIANGULO_4: {
	  Triangulo (ps.hdc, 5.0, y - 5.0, x - 5.0, y - 5.0, x / 2, 5.0, 4);
          break;
	}
	case TRIANGULO_5: {
	  Triangulo (ps.hdc, 5.0, y - 5.0, x - 5.0, y - 5.0, x / 2, 5.0, 5);
          break;
	}
	case TRIANGULO_6: {
	  Triangulo (ps.hdc, 5.0, y - 5.0, x - 5.0, y - 5.0, x / 2, 5.0, 6);
          break;
	}
	case TRIANGULO_7: {
	  Triangulo (ps.hdc, 5.0, y - 5.0, x - 5.0, y - 5.0, x / 2, 5.0, 7);
          break;
	}
	case TRIANGULO_8: {
	  Triangulo (ps.hdc, 5.0, y - 5.0, x - 5.0, y - 5.0, x / 2, 5.0, 8);
          break;
	}
	case TRIANGULO_9: {
	  Triangulo (ps.hdc, 5.0, y - 5.0, x - 5.0, y - 5.0, x / 2, 5.0, 9);
          break;
	}
	case TRIANGULO_10: {
	  Triangulo (ps.hdc, 5.0, y - 5.0, x - 5.0, y - 5.0, x / 2, 5.0, 10);
          break;
	}
      }

      SetCursor (hcursor);
      EndPaint (hwnd, &ps);
    }


    default:
      return (DefWindowProc (hwnd, msg, wParam, lParam));
  }
  return 0L;
}

void Floco (HDC hdc, float x1, float y1, float x2, float y2, int profundidade)
{
  float xmeio, ymeio,
	xcanto1, ycanto1,
	xcanto2, ycanto2,
	xvetor, yvetor,
	aux, distancia;

  xmeio = (x1 + x2) / 2;
  ymeio = (y1 + y2) / 2;

  xcanto1 = (x1 + xmeio) / 2;
  ycanto1 = (y1 + ymeio) / 2;

  xcanto2 = (xmeio + x2) / 2;
  ycanto2 = (ymeio + y2) / 2;

  /* vetor perpendicular */

  xvetor = y2 - y1;
  yvetor = x1 - x2;

  aux = (float) sqrt ((double) xvetor * (double) xvetor +
		      (double) yvetor * (double) yvetor);

  xvetor /= aux;
  yvetor /= aux;

  distancia = (float) sqrt (((double) x2 - (double) x1) *
			    ((double) x2 - (double) x1) +
			    ((double) y2 - (double) y1) *
			    ((double) y2 - (double) y1));

  xvetor *= distancia / 3;
  yvetor *= distancia / 3;

  xmeio += xvetor;
  ymeio += yvetor;

  if (--profundidade == 0) {
    MoveTo (hdc, (int) x1, (int) y1);
    LineTo (hdc, (int) xcanto1, (int) ycanto1);
//    MoveTo (hdc, (int) xcanto1, (int) ycanto1);
    LineTo (hdc, (int) xmeio, (int) ymeio);
    MoveTo (hdc, (int) xmeio, (int) ymeio);
    LineTo (hdc, (int) xcanto2, (int) ycanto2);
    MoveTo (hdc, (int) xcanto2, (int) ycanto2);
    LineTo (hdc, (int) x2, (int) y2);
  }
  else {
    Floco (hdc, x1, y1, xcanto1, ycanto1, profundidade);
    Floco (hdc, xcanto1, ycanto1, xmeio, ymeio, profundidade);
    Floco (hdc, xmeio, ymeio, xcanto2, ycanto2, profundidade);
    Floco (hdc, xcanto2, ycanto2, x2, y2, profundidade);
  }
}

void Triangulo (HDC hdc, float x1, float y1,
		         float x2, float y2,
		         float x3, float y3, int profundidade)
{
  float xmeio1, ymeio1,
	xmeio2, ymeio2,
	xmeio3, ymeio3;

  xmeio1 = (x1 + x2) / 2;
  ymeio1 = (y1 + y2) / 2;

  xmeio2 = (x2 + x3) / 2;
  ymeio2 = (y2 + y3) / 2;

  xmeio3 = (x3 + x1) / 2;
  ymeio3 = (y3 + y1) / 2;

  if (--profundidade == 0) {
    MoveTo (hdc, (int) x1, (int) y1);
    LineTo (hdc, (int) x2, (int) y2);
    MoveTo (hdc, (int) x2, (int) y2);
    LineTo (hdc, (int) x3, (int) y3);
    MoveTo (hdc, (int) x3, (int) y3);
    LineTo (hdc, (int) x1, (int) y1);
  }
  else {
    Triangulo (hdc, x1, y1, xmeio1, ymeio1, xmeio3, ymeio3, profundidade);
    Triangulo (hdc, xmeio1, ymeio1, x2, y2, xmeio2, ymeio2, profundidade);
    Triangulo (hdc, xmeio3, ymeio3, xmeio2, ymeio2, x3, y3, profundidade);
  }

}
